#ifndef ACTOR_H
#define ACTOR_H

//#define MAX_ACTORS 2+MAX_ENEMIES
#define MAX_ACTORS 2+4
#define ENEMY_INDEX_START 2

enum {
	DIR_LEFT = 0,
	DIR_UP,
	DIR_RIGHT,
	DIR_DOWN
};

enum {
	ACTORFLAG_INVISIBLE = 0x10, //actor_asm.s
	ACTORFLAG_PRIORITY = 0x20,
	ACTORFLAG_HFLIP = 0x40,
	ACTORFLAG_VFLIP = 0x80,
};

enum {
	ACTORID_NONE = 0,
	ACTORID_BUNNY,
	ACTORID_SHADOW,
	ACTORID_ENEMY,
	ACTORID_ENEMY2,
	ACTORID_ENEMY3,
	ACTORID_ENEMY4,
	ACTORID_CAT,
};

extern u8 a_id[MAX_ACTORS];
extern u8 a_tx[MAX_ACTORS];
extern u8 a_ty[MAX_ACTORS];
extern u8 a_x[MAX_ACTORS];
extern u8 a_y[MAX_ACTORS];
extern u8 a_xFrac[MAX_ACTORS];
extern u8 a_yFrac[MAX_ACTORS];
extern s8 a_vx[MAX_ACTORS];
extern s8 a_vy[MAX_ACTORS];
extern u8 a_vxFrac[MAX_ACTORS];
extern u8 a_vyFrac[MAX_ACTORS];
extern u8 a_gfxPtr[MAX_ACTORS];
extern u8 a_flags[MAX_ACTORS];
extern u8 a_dispY[MAX_ACTORS];
extern u8 a_timer[MAX_ACTORS];
extern u8 a_anim[MAX_ACTORS];
extern u8 a_animPtr[MAX_ACTORS];
extern u8 a_animDelay[MAX_ACTORS];
extern u8 a_speed[MAX_ACTORS];
extern u8 a_state[MAX_ACTORS];
extern u8 a_moveTimer[MAX_ACTORS];

extern const s8 DIR_DX[];
extern const s8 DIR_DY[];
extern const u16 SPEED[];

void __fastcall__ actor_createAt(u8 i, u8 id, u8 tx, u8 ty);
u8 __fastcall__ actor_create(u8 id, u8 tx, u8 ty);
u8 __fastcall__ actor_createEnemy(u8 id, u8 tx, u8 ty);
void __fastcall__ actor_destroy(u8 i);
u8 __fastcall__ actor_move(u8 i, u8 dir);
void __fastcall__ actor_updateAnimation(u8 i);
void __fastcall__ actor_updateAll(void);
void __fastcall__ actor_callAI(u8 i, u8 sf);
void __fastcall__ actor_setAnimation(u8 i, u8 anim);
void __fastcall__ actor_setFlag(u8 i, u8 flag);
void __fastcall__ actor_replace(u8 i, u8 id);

extern u8 oamPtr;

//AI
extern u8 aiTmp0;
extern u8 aiTmp1;

#define AI_INIT 0
#define AI_UPDATE 1
#define AI_COLLISION 2

#define ai_init(i) actor_callAI(i,AI_INIT)
#define ai_update(i) actor_callAI(i,AI_UPDATE)
#define ai_collision(i,a) aiTmp0=a;actor_callAI(i,AI_COLLISION)


//animation
enum {
	AN_BUNNY_IDLE, AN_BUNNY_DEATH, AN_BUNNY_JUMP
};

enum {
	AN_CAT_IDLE, AN_CAT_RUN
};

enum {
	AN_SHADOW_IDLE
};

enum {
	AN_ENEMY_IDLE, AN_ENEMY_SCARED
};

#endif
