
OAM_BUF = $0200 ;crt0.s
ACTORFLAG_INVISIBLE = $10 ;actor.h

.importzp sp
.import incsp1
.import _a_x, _a_y, _a_xFrac, _a_yFrac, _a_vx, _a_vy, _a_vxFrac, _a_vyFrac
.import _a_anim, _a_animPtr, _a_animDelay, _a_gfxPtr, _a_id, _a_dispY, _a_flags
.import _AD_ANIMDATA, _AD_SIZE, _AD_GFXDATA
.import _oamPtr

.export _actor_updatePosition
.export _actor_updateAnimation
.export _actor_setAnimation
.export _actor_updateOam

.export _ANIM_BUNNY
.export _ANIM_SHADOW
.export _ANIM_ENEMY
.export _ANIM_ENEMY2
.export _ANIM_ENEMY3
.export _ANIM_ENEMY4
.export _ANIM_CAT

.segment "ZEROPAGE"
_tmp0: .res 1
_tmp1: .res 1
_tmp2: .res 1
_tmp3: .res 1
_tmp4: .res 1
_tmp5: .res 1

.segment "CODE"

;animation data
_ANIM_BUNNY_IDLE: .byte 0,0, -2
_ANIM_BUNNY_DEATH: .byte 12,4, 16,4, -2
_ANIM_BUNNY_JUMP: .byte 0,1, 4,11, 0,1, -2
;_ANIM_BUNNY_JUMP: .byte 0,1, 4,5, 8,1, 4,1, 8,1, 4,0, 0,0, -2
;_ANIM_BUNNY_JUMP: .byte 0,1, 4,1, -2
;_ANIM_BUNNY_FALL: .byte 8,1, 12,1, -4
_ANIM_BUNNY: .addr _ANIM_BUNNY_IDLE,_ANIM_BUNNY_DEATH,_ANIM_BUNNY_JUMP

_ANIM_CAT_IDLE: .byte 0,0, -2
_ANIM_CAT_RUN: .byte 0,1, 4,1, 0,1, 8,1, -8
_ANIM_CAT: .addr _ANIM_CAT_IDLE,_ANIM_CAT_RUN

_ANIM_SHADOW_IDLE: .byte 0,1, 2,1, -4
_ANIM_SHADOW: .addr _ANIM_SHADOW_IDLE

_ANIM_ENEMY_IDLE: .byte 0,0, -2
_ANIM_ENEMY_SCARED: .byte 4,0, -2
_ANIM_ENEMY: .addr _ANIM_ENEMY_IDLE,_ANIM_ENEMY_SCARED
_ANIM_ENEMY2: .addr _ANIM_ENEMY_IDLE,_ANIM_ENEMY_SCARED
_ANIM_ENEMY3: .addr _ANIM_ENEMY_IDLE,_ANIM_ENEMY_SCARED
_ANIM_ENEMY4: .addr _ANIM_ENEMY_IDLE,_ANIM_ENEMY_SCARED

.macro inc16 addr
	inc addr
	bne :+
		inc addr+1
	:
.endmacro

;void __fastcall__ abs(s8 v);
.proc _abs
	cmp #$00
	bpl @end
		eor #$FF
		clc
		adc #1
	@end:
	rts
.endproc

;void __fastcall__ actor_updatePosition(u8 i)
.proc _actor_updatePosition
	;x += vx
	tay
	lda _a_xFrac,y
	clc
	adc _a_vxFrac,y
	sta _a_xFrac,y
	lda _a_x,y
	adc _a_vx,y
	sta _a_x,y
	
	;y += vy
	lda _a_yFrac,y
	clc
	adc _a_vyFrac,y
	sta _a_yFrac,y
	lda _a_y,y
	adc _a_vy,y
	sta _a_y,y
	rts
.endproc


;void __fastcall__ actor_updateAnimation(u8 i)
.proc _actor_updateAnimation
	;animDataPtr: _tmp0,_tmp1
	;_tmp2
	tax
	ldy _a_animDelay,x
	beq end
	dec _a_animDelay,x
	bne end
	forceUpdate: ;x(in: actor index)
	;animDataPtr = AD_ANIMDATA[a_id[i]]
		lda _a_id,x
		asl a
		tay
		lda _AD_ANIMDATA,y
		sta _tmp0
		lda _AD_ANIMDATA+1,y
		sta _tmp1
	
	;animDataPtr = animDataPtr[a_anim[i]]
		lda _a_anim,x
		asl a
		tay
		lda (_tmp0),y
		pha
		iny
		lda (_tmp0),y
		sta _tmp1
		pla
		sta _tmp0
		
	ldy _a_animPtr,x
	@readBytes:
		;byte 0 - frame (gfxPtr)
			lda (_tmp0),y
			bpl @skipJump
				jsr _abs
				sta _tmp2
				tya
				sec
				sbc _tmp2
				tay
				jmp @readBytes
			@skipJump:
			sta _a_gfxPtr,x
			iny
			
		;byte 1 - delay
			lda (_tmp0),y
			sta _a_animDelay,x
			inc _a_animDelay,x
			iny
		
		tya
		sta _a_animPtr,x
	end:
	rts
.endproc

;void __fastcall__ actor_setAnimation(u8 i, u8 anim)
.proc _actor_setAnimation
	pha
	;x = i
		ldy #$00
		lda (sp),y
		tax
		tya
		sta _a_animPtr,x
	pla
	cmp _a_anim,x
	beq @end ;do not set animation if it's the same
	sta _a_anim,x
	
	jsr _actor_updateAnimation::forceUpdate
	
	@end:
	jmp incsp1
.endproc

;void __fastcall__ actor_updateOam(u8 i) 
.proc _actor_updateOam
	gfxData = _tmp0 ;,_tmp1
	id = _tmp2
	gfxPtr = _tmp3
	
	tax
	;if(a_flags[i] & ACTORFLAG_INVISIBLE)
	;	return;
		lda _a_flags,x
		and #ACTORFLAG_INVISIBLE
		beq @doIt
			rts
		@doIt:
		
	;id = a_id[i];
		lda _a_id,x
		sta id
	;gfxData = (u8*)AD_GFXDATA[id];
		asl a
		tay
		lda _AD_GFXDATA,y
		sta gfxData
		lda _AD_GFXDATA+1,y
		sta gfxData+1
	;gfxPtr = a_gfxPtr[i];
		lda _a_gfxPtr,x
		sta gfxPtr
	
	;switch(AD_SIZE[id]) {
		ldy id
		lda _AD_SIZE,y
		beq @8x8
		cmp #1
		beq @16x16
		
		@16x8:
			;Byte 1 - Tile index number
			;gfxData[a_gfxPtr[i]]
				ldy gfxPtr
				lda (gfxData),y
				pha
				iny
				lda (gfxData),y
				ldy _oamPtr
				sta OAM_BUF+4*1 + 1,y
				pla
				sta OAM_BUF+4*0 + 1,y
			
			;Byte 0 - Y position of top of sprite
			;a_y[i]-4+a_dispY[i]
				lda _a_y,x
				sec
				sbc #4
				clc
				adc _a_dispY,x
				sta OAM_BUF+4*0 + 0,y
				sta OAM_BUF+4*1 + 0,y
			
			;Byte 3 - X position of left side of sprite
			;a_x[i]
				lda _a_x,x
				sta OAM_BUF+4*1 + 3,y
			;a_x[i]-8
				sec
				sbc #8
				sta OAM_BUF+4*0 + 3,y
			
			;Byte 2 - Attributes
				lda _a_flags,x
				sta OAM_BUF+4*0 + 2,y
				sta OAM_BUF+4*1 + 2,y
				
			;oamPtr += 2*4
				tya
				clc
				adc #2*4
				sta _oamPtr
			rts
			
		@8x8:
			;Byte 1 - Tile index number
			;gfxData[a_gfxPtr[i]]
				ldy gfxPtr
				lda (gfxData),y
				ldy _oamPtr
				sta OAM_BUF+4*0 + 1,y
			
			;Byte 0 - Y position of top of sprite
			;a_y[i]-4+a_dispY[i]
				lda _a_y,x
				sec
				sbc #4
				clc
				adc _a_dispY,x
				sta OAM_BUF+4*0 + 0,y
			
			;Byte 3 - X position of left side of sprite
			;a_x[i]-4
				lda _a_x,x
				sec
				sbc #4
				sta OAM_BUF+4*0 + 3,y
			
			;Byte 2 - Attributes
				lda _a_flags,x
				sta OAM_BUF+4*0 + 2,y
			
			;oamPtr += 4
				tya
				clc
				adc #4
				sta _oamPtr
			rts
			
		@16x16:
			
			;Byte 1 - Tile index number
			;gfxData[a_gfxPtr[i]]
				ldy gfxPtr
				lda (gfxData),y
				pha
				iny
				lda (gfxData),y
				pha
				iny
				lda (gfxData),y
				pha
				iny
				lda (gfxData),y
				ldy _oamPtr
				sta OAM_BUF+4*3 + 1,y
				pla
				sta OAM_BUF+4*2 + 1,y
				pla
				sta OAM_BUF+4*1 + 1,y
				pla
				sta OAM_BUF+4*0 + 1,y
			
			;Byte 0 - Y position of top of sprite
			;a_y[i]+a_dispY[i]
				lda _a_y,x
				clc
				adc _a_dispY,x
				sta OAM_BUF+4*2 + 0,y
				sta OAM_BUF+4*3 + 0,y
			;a_y[i]-8+a_dispY[i]
				sec
				sbc #8
				sta OAM_BUF+4*0 + 0,y
				sta OAM_BUF+4*1 + 0,y
			
			;Byte 3 - X position of left side of sprite
			;a_x[i]
				lda _a_x,x
				sta OAM_BUF+4*1 + 3,y
				sta OAM_BUF+4*3 + 3,y
			;a_x[i]-8
				sec
				sbc #8
				sta OAM_BUF+4*0 + 3,y
				sta OAM_BUF+4*2 + 3,y
			
			;Byte 2 - Attributes
				lda _a_flags,x
				sta OAM_BUF+4*0 + 2,y
				sta OAM_BUF+4*1 + 2,y
				sta OAM_BUF+4*2 + 2,y
				sta OAM_BUF+4*3 + 2,y
				
			;oamPtr += 4*4
				tya
				clc
				adc #4*4
				sta _oamPtr
	@end:
		rts
.endproc

