#ifndef MAP_H
#define MAP_H

#define MAP_WIDTH 16
#define MAP_WSHIFT 4
#define MAP_HEIGHT 15
#define MAP_SIZE (MAP_WIDTH*MAP_HEIGHT)
#define MAX_ENEMIES 4

#define TILEFLAG_PALETTE 0x03
#define TILEFLAG_SOLID 0x80

#define setTile(x,y,t) map[((y)<<MAP_WSHIFT) + (x)] = (t)
#define getTile(x,y) map[((y)<<MAP_WSHIFT) + (x)]
#define getTileIndex(x,y) (((y)<<MAP_WSHIFT) + (x))

void __fastcall__ map_init(void);
void __fastcall__ map_load(u8 level);
void __fastcall__ map_setAndUpdateTile(u8 x, u8 y, u8 t);

extern u8 map[MAP_SIZE];
extern u8 carrotCount;
extern u8 currentLevel;

extern const u8 tileFlags[];

extern u8 enemyId[MAX_ENEMIES];
extern u8 enemySpawnX[MAX_ENEMIES];
extern u8 enemySpawnY[MAX_ENEMIES];
extern u8 enemyRespawnTimer[MAX_ENEMIES];
extern u8 enemyBaseSpeed;

enum {
	TILE_NONE,
	TILE_FLOOR,
	TILE_WALL,
	TILE_CARROT,
	TILE_POST,
	TILE_FLATPOST,
};

#endif
